/***************************************************************************\
|*									   *|
|*  screen.h:	A version of Tetris to run on Linux SVGAlib console.	   *|
|*		This module handles all the operations concerning	   *|
|*		the Jlib bits.          				   *|
|*									   *|
|*  Authors:	Mike Taylor (mirk@uk.ac.warwick.cs) &    		   *|
|*		Arturo Espinosa (arturo@nuclecu.unam.mx)		   *|
|*  Started:	Fri May 26 12:26:05 BST 1989 (tetris for terminals)	   *|
|*	        Dic 1, 1995 (pictetris)					   *|
|*									   *|
\***************************************************************************/

#include <jlib.h>

#define WALL_CHAR	'|'	/* Character used for sides of pay-area */
#define FLOOR_CHAR	'='	/* Character used for base-line */
#define CORNER_CHAR	'+'	/* Character used bottom left and right */
#define BLANK_CHAR	' '	/* Character used elsewhere */

#define PD_DRAW		0	/* Code to draw piece */
#define PD_ERASE	1	/* Code to erase piece */

#define COL(x)  ((x)*CHAR_WIDTH('a'))
#define LINE(x)  ((x)*CHAR_HEIGHT('a'))

/*-------------------------------------------------------------------------*/

extern void myrefresh ();
extern void hoopy_refresh ();
extern void print_msg ();
extern void clear_area ();
extern void setup_screen ();
extern void setup_video ();
extern void load_next_pcx ();
extern void setup_curses ();
extern void update_scores ();
extern void draw_board ();
extern void draw_piece ();
extern void draw_title ();
extern void draw_options(int bg, int nb, int s, int rl, int tt, int gl);
extern void place_piece ();
extern void draw_next_piece_box ();
extern int can_place ();
extern char scan_key(int which);
extern char get_keyboard_key();
extern void flush_keyboard ();

/*-------------------------------------------------------------------------*/

extern buffer_rec *offscreen;
